<template>
  <div>
    <div class="pt-3">
      <div
        v-if="isLoading"
        class="h-16 !relative !min-h-5 flex justify-center items-center"
      >
        <div class="animate-spin w-fit">
          <div class="custom-spinner" />
        </div>
      </div>
      <div v-else>
        <!-- Empty State -->
        <app-empty-state-cta
          v-if="!hasOrganizations"
          icon="ri-community-line"
          title="No organizations yet"
          description="We couldn't track any organizations related to your contacts."
          cta-btn="Add organization"
          @cta-click="onCtaClick"
        />

        <app-empty-state-cta
          v-else-if="hasOrganizations && !totalOrganizations"
          icon="ri-community-line"
          title="No organizations found"
          description="We couldn't find any results that match your search criteria, please try a different query."
        />

        <div v-else>
          <!-- Sorter -->
          <div class="mb-2">
            <app-pagination-sorter
              :page-size="Number(pagination.perPage)"
              :total="totalOrganizations"
              :current-page="pagination.page"
              :has-page-counter="false"
              :export="doExport"
              module="organization"
              position="top"
              @change-sorter="doChangePaginationPageSize"
            >
              <template #defaultFilters>
                <div>・</div>
                <cr-default-filters
                  :config="organizationSavedViews"
                  :settings="filters.settings"
                />
              </template>
            </app-pagination-sorter>
          </div>

          <!-- Organizations list -->
          <div class="app-list-table panel">
            <transition name="el-fade-in">
              <div
                v-show="isScrollbarVisible"
                class="absolute z-20 top-0 left-0 w-full"
                @mouseover="onTableMouseover"
                @mouseleave="onTableMouseLeft"
              >
                <el-scrollbar
                  id="custom-scrollbar"
                  ref="scrollbarRef"
                  height="10px"
                  always
                  @scroll="onCustomScrollbarScroll"
                  @pointerdown="onScrollMousedown"
                >
                  <div
                    :style="{
                      height: '10px',
                    }"
                  />
                </el-scrollbar>
              </div>
            </transition>

            <app-organization-list-toolbar
              :pagination="pagination"
              @mouseover="onTableMouseover"
              @mouseleave="onTableMouseLeft"
            />

            <div
              class="-mx-6 -mt-6"
              @mouseover="onTableMouseover"
              @mouseleave="onTableMouseLeft"
            >
              <el-table
                id="organizations-table"
                ref="table"
                :data="organizations"
                :default-sort="defaultSort"
                row-key="id"
                border
                :row-class-name="rowClass"
                @sort-change="doChangeSort"
                @selection-change="selectedOrganizations = $event"
                @cell-mouse-enter="handleCellMouseEnter"
                @cell-mouse-leave="handleCellMouseLeave"
              >
                <!-- Checkbox -->
                <el-table-column
                  type="selection"
                  width="75"
                  :fixed="!isMobile"
                />

                <!-- Organization logo and name -->
                <el-table-column
                  label="Organization"
                  prop="displayName"
                  width="240"
                  :fixed="!isMobile"
                  sortable
                >
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block mr-4"
                    >
                      <app-organization-name
                        class="w-full"
                        :organization="scope.row"
                      />
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Website -->
                <el-table-column label="Website" width="180">
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div
                        class="text-sm h-full flex items-center"
                      >
                        <a
                          v-if="scope.row.website"
                          class="text-gray-500 hover:!text-brand-500"
                          :href="withHttp(scope.row.website)"
                          target="_blank"
                          rel="noopener noreferrer"
                          @click.stop
                        >{{ scope.row.website }}</a>
                        <span
                          v-else
                          class="text-gray-500"
                        >-</span>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Headline -->
                <el-table-column
                  label="Headline"
                  prop="headline"
                  width="300"
                >
                  <template #header>
                    <div class="flex items-center">
                      <div class="mr-2">
                        Headline
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div class="mr-4">
                        <span
                          v-if="scope.row.headline || scope.row.description"
                          class="text-sm h-full flex items-center text-gray-900"
                        >
                          {{ truncateText((scope.row.headline || scope.row.description), 150, '...') }}
                        </span>
                        <span
                          v-else
                          class="text-gray-500"
                        >-</span>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Identities -->
                <el-table-column
                  label="Identities"
                  width="280"
                >
                  <template #header>
                    <span>Identities</span>
                    <el-tooltip placement="top">
                      <template #content>
                        Identities can be profiles on social platforms, emails,<br>
                        or unique identifiers from internal sources.
                      </template>
                      <i class="ri-information-line text-xs ml-1" />
                    </el-tooltip>
                  </template>
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div class="h-full flex items-center">
                        <app-identities-horizontal-list-organizations
                          :organization="scope.row"
                          :limit="5"
                        />
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Number of members -->
                <el-table-column
                  label="# Contacts"
                  width="150"
                  prop="memberCount"
                  sortable
                >
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div
                        class="text-gray-900 text-sm h-full flex items-center"
                      >
                        {{
                          formatNumberToCompact(
                            scope.row.memberCount,
                          )
                        }}
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Number of activities -->
                <el-table-column
                  label="# Activities"
                  width="150"
                  prop="activityCount"
                  sortable
                >
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div
                        class="text-gray-900 text-sm h-full flex items-center"
                      >
                        {{
                          formatNumberToCompact(
                            scope.row.activityCount,
                          )
                        }}
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- TBD: Last active -->
                <el-table-column
                  label="Last active"
                  prop="lastActive"
                  width="150"
                  sortable="lastActive"
                >
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <span
                        v-if="scope.row.lastActive"
                        class="text-gray-900 text-sm h-full flex items-center"
                      >

                        {{ formatDateToTimeAgo(scope.row.lastActive) }}
                      </span>
                      <span
                        v-else
                        class="text-gray-900"
                      >-</span>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Joined Date -->
                <el-table-column
                  label="Joined Date"
                  width="200"
                  prop="joinedAt"
                  sortable
                >
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div
                        v-if="scope.row.joinedAt"
                        class="text-gray-900 text-sm h-full flex items-center"
                      >
                        {{
                          formatDateToTimeAgo(
                            scope.row.joinedAt,
                          )
                        }}
                      </div>
                      <span
                        v-else
                        class="text-gray-900"
                      >-</span>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Location -->
                <el-table-column
                  label="Location"
                  width="150"
                  prop="location"
                >
                  <template #header>
                    <div class="flex items-center">
                      <div class="mr-2">
                        Location
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block"
                    >
                      <div
                        class="text-sm h-full flex items-center"
                      >
                        <span v-if="scope.row.location" class="text-gray-900">
                          {{
                            scope.row.location
                          }}
                        </span>
                        <span v-else class="text-gray-500">-</span>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Industry -->
                <el-table-column
                  label="Industry"
                  width="150"
                  prop="industry"
                >
                  <template #header>
                    <div
                      :ref="(el) => setEnrichmentAttributesRef(el, 'industry')"
                      class="flex items-center"
                      @mouseover="() => onColumnHeaderMouseOver('industry')"
                      @mouseleave="closeEnrichmentPopover"
                    >
                      <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                        Industry
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-industry`)"
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block h-full"
                    >
                      <div
                        v-if="isEnrichEnabled"
                        class="text-sm h-full flex items-center"
                      >
                        <span v-if="scope.row.industry" class="text-gray-900">
                          {{
                            toSentenceCase(scope.row.industry)
                          }}
                        </span>
                        <span v-else class="text-gray-500">-</span>
                      </div>
                      <div v-else class="flex items-center h-full w-full pl-3">
                        <div class="blur-[6px] text-gray-900 select-none">
                          Software
                        </div>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Headcount -->
                <el-table-column
                  label="Headcount"
                  width="150"
                  prop="size"
                >
                  <template #header>
                    <div
                      :ref="(el) => setEnrichmentAttributesRef(el, 'size')"
                      class="flex items-center"
                      @mouseover="() => onColumnHeaderMouseOver('size')"
                      @mouseleave="closeEnrichmentPopover"
                    >
                      <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                        Headcount
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-size`)"
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block h-full"
                    >
                      <div
                        v-if="isEnrichEnabled"
                        class="text-sm h-full flex items-center"
                      >
                        <span v-if="scope.row.size" class="text-gray-900">
                          {{
                            scope.row.size
                          }}
                        </span>
                        <span v-else class="text-gray-500">-</span>
                      </div>
                      <div v-else class="flex items-center h-full w-full pl-3">
                        <div class="blur-[6px] text-gray-900 select-none">
                          11-50
                        </div>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Inferred Revenue -->
                <el-table-column
                  label="Annual Revenue"
                  prop="revenueRange"
                  width="180"
                >
                  <template #header>
                    <div
                      :ref="(el) => setEnrichmentAttributesRef(el, 'revenueRange')"
                      class="flex items-center"
                      @mouseover="() => onColumnHeaderMouseOver('revenueRange')"
                      @mouseleave="closeEnrichmentPopover"
                    >
                      <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                        Annual Revenue
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-revenueRange`)"
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block h-full"
                    >
                      <div
                        v-if="isEnrichEnabled"
                        class="text-sm h-full flex items-center"
                      >
                        <span v-if="scope.row.revenueRange" class="text-gray-900">
                          {{
                            revenueRange.displayValue(scope.row.revenueRange)
                          }}
                        </span>
                        <span v-else class="text-gray-500">-</span>
                      </div>
                      <div v-else class="flex items-center h-full w-full pl-3">
                        <div class="blur-[6px] text-gray-900 select-none">
                          $1M-$10M
                        </div>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Founded -->
                <el-table-column
                  label="Founded"
                  width="150"
                  prop="founded"
                  sortable
                >
                  <template #header>
                    <div
                      :ref="(el) => setEnrichmentAttributesRef(el, 'founded')"
                      class="inline-block"
                      @mouseover="() => onColumnHeaderMouseOver('founded')"
                      @mouseleave="closeEnrichmentPopover"
                    >
                      <div class="flex items-center">
                        <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                          Founded
                        </div>
                        <el-tooltip content="Source: Enrichment" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                          <app-svg name="source" class="h-3 w-3" />
                        </el-tooltip>
                      </div>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-founded`)"
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block h-full"
                    >
                      <div

                        v-if="isEnrichEnabled"
                        class="text-sm h-full flex items-center"
                      >
                        <span v-if="scope.row.founded" class="text-gray-900">
                          {{
                            scope.row.founded
                          }}
                        </span>
                        <span v-else class="text-gray-500">-</span>
                      </div>
                      <div v-else class="flex items-center h-full w-full pl-3">
                        <div class="blur-[6px] text-gray-900 select-none">
                          2021
                        </div>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Employee Growth Rate -->
                <el-table-column
                  label="Ann. Employee Growth Rate"
                  prop="employeeGrowthRate"
                  width="250"
                >
                  <template #header>
                    <div
                      :ref="(el) => setEnrichmentAttributesRef(el, 'employeeGrowthRate')"
                      class="flex items-center"
                      @mouseover="() => onColumnHeaderMouseOver('employeeGrowthRate')"
                      @mouseleave="closeEnrichmentPopover"
                    >
                      <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                        Ann. Employee Growth Rate
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-employeeGrowthRate`)"
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block h-full"
                    >
                      <div
                        v-if="isEnrichEnabled"
                        class="text-sm h-full flex items-center"
                      >
                        <span v-if="scope.row.employeeGrowthRate?.['12_month']" class="text-gray-900">
                          {{
                            employeeGrowthRate.valueParser(scope.row.employeeGrowthRate['12_month'])
                          }}
                        </span>
                        <span v-else class="text-gray-500">-</span>
                      </div>
                      <div v-else class="flex items-center h-full w-full pl-3">
                        <div class="blur-[6px] text-gray-900 select-none">
                          10.25%
                        </div>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Tags -->
                <el-table-column
                  label="Smart tags"
                  prop="tags"
                  :width="tagsColumnWidth"
                >
                  <template #header>
                    <div
                      :ref="(el) => setEnrichmentAttributesRef(el, 'tags')"
                      class="flex items-center"
                      @mouseover="() => onColumnHeaderMouseOver('tags')"
                      @mouseleave="closeEnrichmentPopover"
                    >
                      <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                        Smart Tags
                      </div>
                      <el-tooltip content="Source: Enrichment" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </template>
                  <template #default="scope">
                    <router-link
                      :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-tags`)"
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="block h-full"
                    >
                      <div v-if="isEnrichEnabled">
                        <app-tag-list
                          v-if="scope.row.tags?.length"
                          :member="{
                            ...scope.row,
                            tags: scope.row.tags.map((t) => ({ id: t, name: t })),
                          }"
                          :editable="false"
                        />
                        <span v-else class="text-gray-500">-</span>
                      </div>
                      <div v-else class="flex items-center h-full w-full pl-3">
                        <div class="blur-[6px] text-gray-900 select-none">
                          Software
                        </div>
                      </div>
                    </router-link>
                  </template>
                </el-table-column>

                <!-- Actions -->
                <el-table-column :fixed="!isMobile && 'right'">
                  <template #default="scope">
                    <router-link
                      :to="{
                        name: 'organizationView',
                        params: { id: scope.row.id },
                      }"
                      class="flex justify-center"
                    >
                      <button
                        :id="`buttonRef-${scope.row.id}`"
                        :ref="(el) => setActionBtnsRef(el, scope.row.id)"
                        class="el-dropdown-link btn p-1.5 rounder-md hover:bg-gray-200 text-gray-600"
                        type="button"
                        @click.prevent.stop="() => onActionBtnClick(scope.row)"
                      >
                        <i
                          :id="`buttonRefIcon-${scope.row.id}`"
                          class="text-xl ri-more-fill"
                        />
                      </button>
                    </router-link>
                  </template>
                </el-table-column>
              </el-table>

              <div
                v-if="showBottomPagination"
                class="mt-8 px-6"
              >
                <app-pagination
                  :total="totalOrganizations"
                  :page-size="Number(pagination.perPage)"
                  :current-page="pagination.page || 1"
                  module="organization"
                  @change-current-page="
                    doChangePaginationCurrentPage
                  "
                  @change-page-size="
                    doChangePaginationPageSize
                  "
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- Actions dropdown popover -->
    <el-popover
      placement="bottom-end"
      popper-class="popover-dropdown"
      :virtual-ref="actionBtnRefs[selectedActionOrganization?.id]"
      trigger="click"
      :visible="showOrganizationDropdownPopover"
      virtual-triggering
    >
      <div v-click-outside="onClickOutside">
        <app-organization-dropdown-content
          v-if="selectedActionOrganization"
          :organization="selectedActionOrganization"
          :hide-unmerge="true"
          @merge="isMergeDialogOpen = selectedActionOrganization"
          @close-dropdown="closeDropdown"
        />
      </div>
    </el-popover>

    <!-- Enrichment popover -->
    <el-popover
      v-if="!isEnrichEnabled"
      placement="top"
      popper-class="!p-0 !mb-[-12px] !w-60"
      :virtual-ref="enrichmentRefs[selectedEnrichmentAttribute]"
      trigger="hover"
      :visible="showEnrichmentPopover"
      virtual-triggering
      @hide="onHide"
    >
      <cr-enrichment-sneak-peak-content id="popover-content" type="organization" @mouseleave="closeEnrichmentPopover" />
    </el-popover>

    <app-organization-merge-dialog v-model="isMergeDialogOpen" />
  </div>
</template>

<script setup>
import {
  computed,
  ref,
  watch,
  onUnmounted,
} from 'vue';
import { useRouter } from 'vue-router';
import { formatDateToTimeAgo } from '@/utils/date';
import { formatNumberToCompact } from '@/utils/number';
import { withHttp, toSentenceCase, truncateText } from '@/utils/string';
import { useOrganizationStore } from '@/modules/organization/store/pinia';
import { storeToRefs } from 'pinia';
import AppOrganizationMergeDialog from '@/modules/organization/components/organization-merge-dialog.vue';
import employeeGrowthRate from '@/modules/organization/config/enrichment/employeeGrowthRate';
import revenueRange from '@/modules/organization/config/enrichment/revenueRange';
import AppTagList from '@/modules/tag/components/tag-list.vue';
import { ClickOutside as vClickOutside } from 'element-plus';
import AppSvg from '@/shared/svg/svg.vue';
import CrEnrichmentSneakPeakContent from '@/shared/modules/enrichment/components/enrichment-sneak-peak-content.vue';
import { mapGetters } from '@/shared/vuex/vuex.helpers';
import Plans from '@/security/plans';
import AppIdentitiesHorizontalListOrganizations from '@/shared/modules/identities/components/identities-horizontal-list-organizations.vue';
import { OrganizationService } from '@/modules/organization/organization-service';
import CrDefaultFilters from '@/shared/modules/default-filters/components/default-filters.vue';
import AppOrganizationListToolbar from './organization-list-toolbar.vue';
import AppOrganizationName from '../organization-name.vue';
import AppOrganizationDropdownContent from '../organization-dropdown-content.vue';
import { organizationSavedViews } from '../../config/saved-views/main';
import { useStore } from 'vuex';

const router = useRouter();

const props = defineProps({
  hasOrganizations: {
    type: Boolean,
    default: () => false,
  },
  isPageLoading: {
    type: Boolean,
    default: () => true,
  },
  pagination: {
    type: Object,
    default: () => ({
      page: 1,
      perPage: 20,
    }),
  },
});

const emit = defineEmits(['update:pagination']);

const organizationStore = useOrganizationStore();
const {
  organizations, selectedOrganizations, filters, totalOrganizations, savedFilterBody,
} = storeToRefs(organizationStore);

const isMergeDialogOpen = ref(null);
const table = ref(null);
const scrollbarRef = ref();
const tableBodyRef = ref();
const tableHeaderRef = ref();
const isScrollbarVisible = ref(false);
const isTableHovered = ref(false);
const isCursorDown = ref(false);

const showOrganizationDropdownPopover = ref(false);
const actionBtnRefs = ref({});
const selectedActionOrganization = ref(null);

const showEnrichmentPopover = ref(false);
const enrichmentRefs = ref({});
const selectedEnrichmentAttribute = ref(null);

const { currentTenant } = mapGetters('auth');

const isEnrichEnabled = computed(() => currentTenant.value?.plan !== Plans.values.starter);

const pagination = computed({
  get() {
    return props.pagination;
  },
  set(value) {
    emit('update:pagination', value);
  },
});

const defaultSort = computed(() => ({
  prop: filters.value.order.prop,
  order: filters.value.order.order,
}));

const showBottomPagination = computed(() => (
  !!totalOrganizations.value
    && Math.ceil(
      totalOrganizations.value / Number(pagination.value.perPage),
    ) > 1
));
const isLoading = computed(() => props.isPageLoading);

const tagsColumnWidth = computed(() => {
  let maxTabWidth = 0;

  organizations.value.forEach((row) => {
    if (row.tags) {
      const tabWidth = row.tags
        .map((tag) => tag.length * 20)
        .reduce((a, b) => a + b, 0);

      if (tabWidth > maxTabWidth) {
        maxTabWidth = tabWidth;
      }
    }
  });

  return Math.min(maxTabWidth + 150, 500);
});

document.onmouseup = () => {
  // As soon as mouse is released, set scrollbar visibility
  // according to wether the mouse is hovering the table or not
  isScrollbarVisible.value = isTableHovered.value;
  isCursorDown.value = false;
};

const setActionBtnsRef = (el, id) => {
  if (el) {
    actionBtnRefs.value[id] = el;
  }
};

const onActionBtnClick = (organization) => {
  if (selectedActionOrganization.value?.id === organization.id) {
    showOrganizationDropdownPopover.value = false;

    setTimeout(() => {
      selectedActionOrganization.value = null;
    }, 200);
  } else {
    showOrganizationDropdownPopover.value = true;
    selectedActionOrganization.value = organization;
  }
};

const setEnrichmentAttributesRef = (el, id) => {
  if (el) {
    enrichmentRefs.value[id] = el;
  }
};

const handleCellMouseEnter = (row, column) => {
  const validValues = ['industry', 'size', 'revenueRange', 'founded', 'employeeGrowthRate', 'tags'];

  if (validValues.includes(column.property)) {
    showEnrichmentPopover.value = true;
    selectedEnrichmentAttribute.value = `${row.id}-${column.property}`;
  }
};

const onColumnHeaderMouseOver = (id) => {
  showEnrichmentPopover.value = true;
  selectedEnrichmentAttribute.value = id;
};

const handleCellMouseLeave = (_row, column) => {
  const validValues = ['industry', 'size', 'revenueRange', 'founded', 'employeeGrowthRate', 'tags'];

  if (!validValues.includes(column.property)) {
    closeEnrichmentPopover();
  }
};

const closeEnrichmentPopover = (ev) => {
  if (ev?.toElement?.id !== 'popover-content') {
    showEnrichmentPopover.value = false;

    setTimeout(() => {
      selectedEnrichmentAttribute.value = null;
    }, 100);
  }
};

const closeDropdown = () => {
  showOrganizationDropdownPopover.value = false;

  setTimeout(() => {
    selectedActionOrganization.value = null;
  }, 200);
};

const onClickOutside = (el) => {
  if (!el.target?.id.includes('buttonRef')) {
    closeDropdown();
  }
};

function doChangeSort(sorter) {
  filters.value.order = {
    prop: sorter.prop,
    order: sorter.order,
  };
}

function doChangePaginationCurrentPage(currentPage) {
  emit('update:pagination', {
    ...pagination.value,
    page: currentPage,
  });
}

function doChangePaginationPageSize(pageSize) {
  emit('update:pagination', {
    page: 1,
    perPage: pageSize,
  });
}

const onCtaClick = () => {
  router.push({
    name: 'organizationCreate',
  });
};

const rowClass = ({ row }) => {
  const isSelected = selectedOrganizations.value.find((r) => r.id === row.id)
    !== undefined;

  return isSelected ? 'is-selected' : '';
};

// On custom scrollbar scroll, set the table scroll with the same value
const onCustomScrollbarScroll = ({ scrollLeft }) => {
  table.value.setScrollLeft(scrollLeft);
};

// On table body scroll, set the custom scrollbar scroll with the same value
const onTableBodyScroll = () => {
  scrollbarRef.value.setScrollLeft(
    tableBodyRef.value.scrollLeft,
  );
};

// On table header scroll, set the custom scrollbar scroll with the same value
const onTableHeaderScroll = () => {
  scrollbarRef.value.setScrollLeft(
    tableHeaderRef.value.scrollLeft,
  );
  table.value.setScrollLeft(tableHeaderRef.value.scrollLeft);
};

const onScrollMousedown = () => {
  isCursorDown.value = true;
};

const onTableMouseover = () => {
  isTableHovered.value = true;
  isScrollbarVisible.value = true;
};

const onTableMouseLeft = () => {
  isTableHovered.value = false;
  isScrollbarVisible.value = isCursorDown.value;
};

const store = useStore();
const isMobile = computed(() => store.getters['layout/isMobile']);

const doExport = () => OrganizationService.export({
  filter: savedFilterBody.value.filter,
  orderBy: savedFilterBody.value.orderBy,
  limit: totalOrganizations.value,
  offset: null,
});

watch(table, (newValue) => {
  // Add scroll events to table, it's not possible to access it from 'el-table'
  // as the overflowed element is within it
  const tableBodyEl = document.querySelector(
    '#organizations-table .el-scrollbar__wrap',
  );
  const tableHeaderEl = document.querySelector(
    '#organizations-table .el-table__header-wrapper',
  );

  if (tableBodyEl) {
    tableBodyRef.value = tableBodyEl;
    tableBodyRef.value.addEventListener(
      'scroll',
      onTableBodyScroll,
    );
  }

  if (tableHeaderEl) {
    tableHeaderEl.style.overflow = 'auto';
    tableHeaderRef.value = tableHeaderEl;
    tableHeaderRef.value.addEventListener(
      'scroll',
      onTableHeaderScroll,
    );
  }
});

// Remove listeners on unmount
onUnmounted(() => {
  tableBodyRef.value?.removeEventListener(
    'scroll',
    onTableBodyScroll,
  );
  tableHeaderRef.value?.removeEventListener(
    'scroll',
    onTableHeaderScroll,
  );
});
</script>

<script>
export default {
  name: 'AppOrganizationListTable',
};
</script>

<style lang="scss">
// Hide table header scrollbar
#organizations-table .el-table__header-wrapper {
  // IE, Edge and Firefox
  -ms-overflow-style: none;
  scrollbar-width: none;

  // Chrome, Safari and Opera
  &::-webkit-scrollbar {
    display: none;
  }
}

#organizations-table
.el-table__cell:not(.el-table-column--selection) {
  padding: 0;
}
.el-table tbody .cell {
  display: block !important;
  @apply p-0;
  &,
  & > a {
    @apply h-full w-full flex items-center;
  }
  & > a {
    @apply px-2.5 py-2;
  }
}
.el-table__body {
  height: 1px;
}

.popover-dropdown {
  padding: 0.5rem !important;
  width: fit-content !important;
}
</style>
